diff --git src/video/cocoa/SDL_cocoaclipboard.m src/video/cocoa/SDL_cocoaclipboard.m
index 5b32bbca0..d5d4b505f 100644
--- src/video/cocoa/SDL_cocoaclipboard.m
+++ src/video/cocoa/SDL_cocoaclipboard.m
@@ -26,7 +26,7 @@
 #include "../../events/SDL_clipboardevents_c.h"
 
 int Cocoa_SetClipboardText(_THIS, const char *text)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *data = (__bridge SDL_VideoData *) _this->driverdata;
     NSPasteboard *pasteboard;
@@ -44,7 +44,7 @@ int Cocoa_SetClipboardText(_THIS, const char *text)
 }}
 
 char *Cocoa_GetClipboardText(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSPasteboard *pasteboard;
     NSString *format = NSPasteboardTypeString;
@@ -83,7 +83,7 @@ SDL_bool Cocoa_HasClipboardText(_THIS)
 }
 
 void Cocoa_CheckClipboardUpdate(SDL_VideoData * data)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSPasteboard *pasteboard;
     NSInteger count;
diff --git src/video/cocoa/SDL_cocoacompat.h src/video/cocoa/SDL_cocoacompat.h
new file mode 100644
index 000000000..d9fc0a863
--- /dev/null
+++ src/video/cocoa/SDL_cocoacompat.h
@@ -0,0 +1,138 @@
+/*
+  Simple DirectMedia Layer
+  Copyright (C) 1997-2025 Sam Lantinga <slouken@libsdl.org>
+
+  This software is provided 'as-is', without any express or implied
+  warranty.  In no event will the authors be held liable for any damages
+  arising from the use of this software.
+
+  Permission is granted to anyone to use this software for any purpose,
+  including commercial applications, and to alter it and redistribute it
+  freely, subject to the following restrictions:
+
+  1. The origin of this software must not be misrepresented; you must not
+     claim that you wrote the original software. If you use this software
+     in a product, an acknowledgment in the product documentation would be
+     appreciated but is not required.
+  2. Altered source versions must be plainly marked as such, and must not be
+     misrepresented as being the original software.
+  3. This notice may not be removed or altered from any source distribution.
+*/
+#include "../../SDL_internal.h"
+
+#ifndef SDL_cocoacompat_h_
+#define SDL_cocoacompat_h_
+
+/* Compatibility layer that lets the Cocoa backend build in two modes:
+
+   - clang with Objective-C ARC (the upstream default; modern macOS), and
+   - GCC with manual retain/release, for legacy macOS (10.5/10.6, PowerPC)
+     where clang is not available.
+
+   GCC's Objective-C has no ARC, no blocks, no @autoreleasepool and no
+   instancetype; on top of that, pre-10.7 SDKs lack a number of constants
+   and functions.  Everything here compiles away to the stock spelling
+   under clang/ARC. */
+
+#ifndef __has_feature
+#define __has_feature(x) 0
+#endif
+
+#if __has_feature(objc_arc)
+#define SDL_COCOA_ARC 1
+#else
+#define SDL_COCOA_ARC 0
+#endif
+
+#if !defined(__clang__)
+/* Make ARC bridge casts vanish: (__bridge NSWindow *)ptr -> (NSWindow *)ptr */
+#ifndef __bridge
+#define __bridge
+#endif
+#ifndef instancetype
+#define instancetype id
+#endif
+/* The code paths that actually use blocks are all guarded to clang, so
+   __block locals become plain locals.  Apple GCC 4.2 predefines __block as a
+   built-in macro, hence the #undef. */
+#undef __block
+#define __block
+#endif /* !__clang__ */
+
+/* ARC ivar/local qualifiers */
+#if SDL_COCOA_ARC
+#define SDL_COCOA_WEAK __weak
+#else
+#define SDL_COCOA_WEAK /* unretained plain pointer under MRR */
+#endif
+
+/* Ownership transfer between ObjC objects and void * driverdata.
+   SDL_CFBridgingRetain: +1 retain, returns a void pointer.
+   SDL_CFBridgingRelease: consumes that +1, returns the object (still
+   valid: ARC-managed / autoreleased under MRR). */
+#if SDL_COCOA_ARC
+#define SDL_CFBridgingRetain(obj)  ((void *)CFBridgingRetain(obj))
+#define SDL_CFBridgingRelease(ptr) CFBridgingRelease(ptr)
+#else
+/* the typedef keeps the casts working in scopes where a local variable
+   shadows 'id' (e.g. Cocoa_CreateSystemCursor's parameter) */
+typedef id SDL_cocoa_id;
+#define SDL_CFBridgingRetain(obj)  ((void *)[(SDL_cocoa_id)(obj) retain])
+#define SDL_CFBridgingRelease(ptr) ((SDL_cocoa_id)[(SDL_cocoa_id)(ptr) autorelease])
+#endif
+
+/* Explicit retain/release/autorelease that compile away under ARC.
+   Used where MRR needs an ownership operation that ARC does implicitly.
+   Variadic because the argument is often a [bracketed message send] whose
+   commas square brackets do not hide from the preprocessor. */
+#if SDL_COCOA_ARC
+#define SDL_COCOA_RETAIN(...)      (__VA_ARGS__)
+#define SDL_COCOA_RELEASE(...)     do { } while (0)
+#define SDL_COCOA_AUTORELEASE(...) (__VA_ARGS__)
+#else
+#define SDL_COCOA_RETAIN(...)      [(__VA_ARGS__) retain]
+#define SDL_COCOA_RELEASE(...)     [(__VA_ARGS__) release]
+#define SDL_COCOA_AUTORELEASE(...) [(__VA_ARGS__) autorelease]
+#endif
+
+/* @autoreleasepool replacement.  GCC cannot parse @autoreleasepool, so
+   spell pools as SDL_COCOA_POOL { ... }.  The GCC version is a plain
+   declaration whose cleanup attribute drains the pool when the enclosing
+   scope exits (including early return/goto) - slightly wider than the
+   braces, but every use is the first statement of a function body, where
+   the two are equivalent.  For the same reason it can only be used once
+   per scope, and (because of -Wdeclaration-after-statement) only at the
+   top of a block. */
+#if defined(__clang__)
+#define SDL_COCOA_POOL @autoreleasepool
+#else
+static inline void SDL_CocoaDrainPool(NSAutoreleasePool **pool)
+{
+    [*pool drain];
+}
+#define SDL_COCOA_POOL                                                        \
+    NSAutoreleasePool *sdl_pool_                                              \
+        __attribute__((__cleanup__(SDL_CocoaDrainPool), __unused__))          \
+        = [[NSAutoreleasePool alloc] init];
+#endif
+
+/* Pre-10.7 SDK fallbacks */
+
+#ifndef NSAppKitVersionNumber10_6
+#define NSAppKitVersionNumber10_6 1038
+#endif
+#ifndef NSAppKitVersionNumber10_7
+#define NSAppKitVersionNumber10_7 1138
+#endif
+#ifndef NSAppKitVersionNumber10_8
+#define NSAppKitVersionNumber10_8 1187
+#endif
+
+#if MAC_OS_X_VERSION_MAX_ALLOWED < 1060
+/* The pasteboard type constants were introduced with the 10.6 SDK. */
+#define NSPasteboardTypeString NSStringPboardType
+#endif
+
+#endif /* SDL_cocoacompat_h_ */
+
+/* vi: set ts=4 sw=4 expandtab: */
diff --git src/video/cocoa/SDL_cocoaevents.m src/video/cocoa/SDL_cocoaevents.m
index 39c5c4f38..de686770d 100644
--- src/video/cocoa/SDL_cocoaevents.m
+++ src/video/cocoa/SDL_cocoaevents.m
@@ -116,7 +116,7 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
 
 + (void)registerUserDefaults
 {
-    NSDictionary *appDefaults = [[NSDictionary alloc] initWithObjectsAndKeys:
+    NSDictionary *appDefaults = [NSDictionary dictionaryWithObjectsAndKeys:
                                  [NSNumber numberWithBool:NO], @"AppleMomentumScrollSupported",
                                  [NSNumber numberWithBool:NO], @"ApplePressAndHoldEnabled",
                                  [NSNumber numberWithBool:YES], @"ApplePersistenceIgnoreState",
@@ -131,7 +131,11 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
 - (void)setAppleMenu:(NSMenu *)menu;
 @end
 
+#ifdef MAC_OS_X_VERSION_10_6 /* delegate protocols were introduced with the 10.6 SDK */
 @interface SDLAppDelegate : NSObject <NSApplicationDelegate> {
+#else
+@interface SDLAppDelegate : NSObject {
+#endif
 @public
     BOOL seenFirstActivate;
 }
@@ -183,6 +187,10 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
             removeEventHandlerForEventClass:kInternetEventClass
                                  andEventID:kAEGetURL];
     }
+
+#if !SDL_COCOA_ARC
+    [super dealloc];
+#endif
 }
 
 - (void)windowWillClose:(NSNotification *)notification;
@@ -209,14 +217,17 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
      */
     for (NSWindow *window in [NSApp orderedWindows]) {
         if (window != win && [window canBecomeKeyWindow]) {
+#ifdef MAC_OS_X_VERSION_10_6 /* -isOnActiveSpace arrived with the 10.6 SDK */
             if (![window isOnActiveSpace]) {
                 continue;
             }
+#endif
             [window makeKeyAndOrderFront:self];
             return;
         }
     }
 
+#ifdef MAC_OS_X_VERSION_10_6 /* +windowNumbersWithOptions: arrived with the 10.6 SDK */
     /* If a window wasn't found above, iterate through all visible windows in
      * the active Space in z-order (including the 'About' window, if it's shown)
      * and make the first one key.
@@ -228,6 +239,7 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
             return;
         }
     }
+#endif
 }
 
 - (void)focusSomeWindow:(NSNotification *)aNotification
@@ -295,17 +307,19 @@ static void Cocoa_DispatchEvent(NSEvent *theEvent)
        behaviour there.  https://github.com/libsdl-org/SDL/issues/10340
        (13.6 still needs it, presumably 13.7 does, too.) */
     SDL_bool background_app_default = SDL_FALSE;
-    if (@available(macOS 14.0, *)) {
+    if (floor(NSAppKitVersionNumber) >= 2487 /* NSAppKitVersionNumber14_0 */) {
         background_app_default = SDL_TRUE;  /* by default, don't explicitly activate the dock and then us again to force to foreground */
     }
 
     if (!SDL_GetHintBoolean(SDL_HINT_MAC_BACKGROUND_APP, background_app_default)) {
+#ifdef MAC_OS_X_VERSION_10_6 /* NSRunningApplication arrived with the 10.6 SDK */
         /* Get more aggressive for Catalina: activate the Dock first so we definitely reset all activation state. */
         for (NSRunningApplication *i in [NSRunningApplication runningApplicationsWithBundleIdentifier:@"com.apple.dock"]) {
             [i activateWithOptions:NSApplicationActivateIgnoringOtherApps];
             break;
         }
         SDL_Delay(300);  /* !!! FIXME: this isn't right. */
+#endif
         [NSApp activateIgnoringOtherApps:YES];
     }
 
@@ -401,6 +415,7 @@ static void CreateApplicationMenus(void)
 
     /* Create the main menu bar */
     [NSApp setMainMenu:mainMenu];
+    SDL_COCOA_RELEASE(mainMenu); /* NSApp owns it now */
 
     /* Create the application menu */
     appName = GetApplicationName();
@@ -421,6 +436,7 @@ static void CreateApplicationMenus(void)
     [menuItem setSubmenu:serviceMenu];
 
     [NSApp setServicesMenu:serviceMenu];
+    SDL_COCOA_RELEASE(serviceMenu);
 
     [appleMenu addItem:[NSMenuItem separatorItem]];
 
@@ -441,9 +457,11 @@ static void CreateApplicationMenus(void)
     menuItem = [[NSMenuItem alloc] initWithTitle:@"" action:nil keyEquivalent:@""];
     [menuItem setSubmenu:appleMenu];
     [[NSApp mainMenu] addItem:menuItem];
+    SDL_COCOA_RELEASE(menuItem);
 
     /* Tell the application object that this is now the application menu */
     [NSApp setAppleMenu:appleMenu];
+    SDL_COCOA_RELEASE(appleMenu);
 
     /* Create the window menu */
     windowMenu = [[NSMenu alloc] initWithTitle:@"Window"];
@@ -462,18 +480,21 @@ static void CreateApplicationMenus(void)
     menuItem = [[NSMenuItem alloc] initWithTitle:@"Toggle Full Screen" action:@selector(toggleFullScreen:) keyEquivalent:@"f"];
     [menuItem setKeyEquivalentModifierMask:NSEventModifierFlagControl | NSEventModifierFlagCommand];
     [windowMenu addItem:menuItem];
+    SDL_COCOA_RELEASE(menuItem);
 
     /* Put menu into the menubar */
     menuItem = [[NSMenuItem alloc] initWithTitle:@"Window" action:nil keyEquivalent:@""];
     [menuItem setSubmenu:windowMenu];
     [[NSApp mainMenu] addItem:menuItem];
+    SDL_COCOA_RELEASE(menuItem);
 
     /* Tell the application object that this is now the window menu */
     [NSApp setWindowsMenu:windowMenu];
+    SDL_COCOA_RELEASE(windowMenu);
 }
 
 void Cocoa_RegisterApp(void)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     /* This can get called more than once! Be careful what you initialize! */
 
@@ -484,7 +505,12 @@ void Cocoa_RegisterApp(void)
         s_bShouldHandleEventsInSDLApplication = SDL_TRUE;
 
         if (!SDL_GetHintBoolean(SDL_HINT_MAC_BACKGROUND_APP, SDL_FALSE)) {
+#ifdef MAC_OS_X_VERSION_10_6 /* -setActivationPolicy: arrived with the 10.6 SDK */
             [NSApp setActivationPolicy:NSApplicationActivationPolicyRegular];
+#else
+            ProcessSerialNumber psn = { 0, kCurrentProcess };
+            TransformProcessType(&psn, kProcessTransformToForegroundApplication);
+#endif
         }
 
         /* If there aren't already menus in place, look to see if there's
@@ -552,7 +578,7 @@ int Cocoa_PumpEventsUntilDate(_THIS, NSDate *expiration, bool accumulate)
 }
 
 int Cocoa_WaitEventTimeout(_THIS, int timeout)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     if (timeout > 0) {
         NSDate *limitDate = [NSDate dateWithTimeIntervalSinceNow: (double) timeout / 1000.0];
@@ -567,13 +593,13 @@ int Cocoa_WaitEventTimeout(_THIS, int timeout)
 }}
 
 void Cocoa_PumpEvents(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     Cocoa_PumpEventsUntilDate(_this, [NSDate distantPast], true);
 }}
 
 void Cocoa_SendWakeupEvent(_THIS, SDL_Window *window)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSEvent* event = [NSEvent otherEventWithType: NSEventTypeApplicationDefined
                                     location: NSMakePoint(0,0)
@@ -589,7 +615,7 @@ void Cocoa_SendWakeupEvent(_THIS, SDL_Window *window)
 }}
 
 void Cocoa_SuspendScreenSaver(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *data = (__bridge SDL_VideoData *)_this->driverdata;
 
@@ -606,10 +632,22 @@ void Cocoa_SuspendScreenSaver(_THIS)
          */
         IOPMAssertionID assertion = kIOPMNullAssertionID;
         NSString *name = [GetApplicationName() stringByAppendingString:@" using SDL_DisableScreenSaver"];
+#if defined(MAC_OS_X_VERSION_10_7)
         IOPMAssertionCreateWithDescription(kIOPMAssertPreventUserIdleDisplaySleep,
                                            (__bridge CFStringRef) name,
                                            NULL, NULL, NULL, 0, NULL,
                                            &assertion);
+#elif defined(MAC_OS_X_VERSION_10_6)
+        IOPMAssertionCreateWithName(kIOPMAssertionTypeNoDisplaySleep,
+                                    kIOPMAssertionLevelOn,
+                                    (__bridge CFStringRef) name,
+                                    &assertion);
+#else
+        /* 10.5 only has the nameless variant */
+        (void) name;
+        IOPMAssertionCreate(kIOPMAssertionTypeNoDisplaySleep,
+                            kIOPMAssertionLevelOn, &assertion);
+#endif
         data.screensaver_assertion = assertion;
     }
 }}
diff --git src/video/cocoa/SDL_cocoakeyboard.m src/video/cocoa/SDL_cocoakeyboard.m
index 2a6763228..544b1266a 100644
--- src/video/cocoa/SDL_cocoakeyboard.m
+++ src/video/cocoa/SDL_cocoakeyboard.m
@@ -109,7 +109,8 @@
     }
 
     if (_markedText != aString) {
-        _markedText = aString;
+        SDL_COCOA_RELEASE(_markedText);
+        _markedText = SDL_COCOA_RETAIN(aString);
     }
 
     _selectedRange = selectedRange;
@@ -124,11 +125,20 @@
 
 - (void)unmarkText
 {
+    SDL_COCOA_RELEASE(_markedText);
     _markedText = nil;
 
     SDL_SendEditingText("", 0, 0);
 }
 
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [_markedText release];
+    [super dealloc];
+}
+#endif
+
 - (NSRect)firstRectForCharacterRange:(NSRange)aRange actualRange:(NSRangePointer)actualRange
 {
     NSWindow *window = [self window];
@@ -145,7 +155,11 @@
             aRange.location, aRange.length, windowHeight,
             NSStringFromRect(rect));
 
+#ifdef MAC_OS_X_VERSION_10_7
     rect = [window convertRectToScreen:rect];
+#else
+    rect.origin = [window convertBaseToScreen:rect.origin];
+#endif
 
     return rect;
 }
@@ -325,12 +339,17 @@ void Cocoa_InitKeyboard(_THIS)
     SDL_SetScancodeName(SDL_SCANCODE_RALT, "Right Option");
     SDL_SetScancodeName(SDL_SCANCODE_RGUI, "Right Command");
 
+#ifdef MAC_OS_X_VERSION_10_6 /* +[NSEvent modifierFlags] arrived with the 10.6 SDK */
     data.modifierFlags = (unsigned int)[NSEvent modifierFlags];
+#else
+    /* same NX_* bit values as the AppKit modifier masks */
+    data.modifierFlags = (unsigned int)CGEventSourceFlagsState(kCGEventSourceStateCombinedSessionState);
+#endif
     SDL_ToggleModState(KMOD_CAPS, (data.modifierFlags & NSEventModifierFlagCapsLock) ? SDL_TRUE : SDL_FALSE);
 }
 
 void Cocoa_StartTextInput(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     NSView *parentView;
     SDL_VideoData *data = (__bridge SDL_VideoData *) _this->driverdata;
@@ -348,8 +367,10 @@ void Cocoa_StartTextInput(_THIS)
      * text input, simply remove the field editor from its superview then add
      * it to the front most window's content view */
     if (!data.fieldEdit) {
-        data.fieldEdit =
+        SDLTranslatorResponder *fieldEdit =
             [[SDLTranslatorResponder alloc] initWithFrame: NSMakeRect(0.0, 0.0, 0.0, 0.0)];
+        data.fieldEdit = fieldEdit;
+        SDL_COCOA_RELEASE(fieldEdit); /* the property holds a reference */
     }
 
     if (![[data.fieldEdit superview] isEqual:parentView]) {
@@ -361,7 +382,7 @@ void Cocoa_StartTextInput(_THIS)
 }}
 
 void Cocoa_StopTextInput(_THIS)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     SDL_VideoData *data = (__bridge SDL_VideoData *) _this->driverdata;
 
diff --git src/video/cocoa/SDL_cocoamessagebox.m src/video/cocoa/SDL_cocoamessagebox.m
index 20eabe3ee..7ac760c97 100644
--- src/video/cocoa/SDL_cocoamessagebox.m
+++ src/video/cocoa/SDL_cocoamessagebox.m
@@ -47,7 +47,7 @@
 
         /* Retain the NSWindow because we'll show the alert later on the main thread */
         if (window) {
-            nswindow = ((__bridge SDL_WindowData *) window->driverdata).nswindow;
+            nswindow = SDL_COCOA_RETAIN(((__bridge SDL_WindowData *) window->driverdata).nswindow);
         } else {
             nswindow = nil;
         }
@@ -56,10 +56,18 @@
     return self;
 }
 
+#if !SDL_COCOA_ARC
+- (void)dealloc
+{
+    [nswindow release];
+    [super dealloc];
+}
+#endif
+
 - (void)showAlert:(NSAlert*)alert
 {
     if (nswindow) {
-#if MAC_OS_X_VERSION_MAX_ALLOWED >= 1090
+#if (MAC_OS_X_VERSION_MAX_ALLOWED >= 1090) && defined(__clang__)
         if ([alert respondsToSelector:@selector(beginSheetModalForWindow:completionHandler:)]) {
             [alert beginSheetModalForWindow:nswindow
                       completionHandler:^(NSModalResponse returnCode) {
@@ -73,6 +81,7 @@
 #endif
         }
         clicked = [NSApp runModalForWindow:nswindow];
+        SDL_COCOA_RELEASE(nswindow);
         nswindow = nil;
     } else {
         clicked = [alert runModal];
@@ -97,7 +106,7 @@ static void Cocoa_ShowMessageBoxImpl(const SDL_MessageBoxData *messageboxdata, i
     int i;
     Cocoa_RegisterApp();
 
-    alert = [[NSAlert alloc] init];
+    alert = SDL_COCOA_AUTORELEASE([[NSAlert alloc] init]);
 
     if (messageboxdata->flags & SDL_MESSAGEBOX_ERROR) {
         [alert setAlertStyle:NSAlertStyleCritical];
@@ -130,7 +139,7 @@ static void Cocoa_ShowMessageBoxImpl(const SDL_MessageBoxData *messageboxdata, i
         }
     }
 
-    presenter = [[SDLMessageBoxPresenter alloc] initWithParentWindow:messageboxdata->window];
+    presenter = SDL_COCOA_AUTORELEASE([[SDLMessageBoxPresenter alloc] initWithParentWindow:messageboxdata->window]);
 
     [presenter showAlert:alert];
 
@@ -149,14 +158,22 @@ static void Cocoa_ShowMessageBoxImpl(const SDL_MessageBoxData *messageboxdata, i
 
 /* Display a Cocoa message box */
 int Cocoa_ShowMessageBox(const SDL_MessageBoxData *messageboxdata, int *buttonid)
-{ @autoreleasepool
+{ SDL_COCOA_POOL
 {
     __block int returnValue = 0;
 
     if ([NSThread isMainThread]) {
         Cocoa_ShowMessageBoxImpl(messageboxdata, buttonid, &returnValue);
     } else {
+#if defined(__clang__)
         dispatch_sync(dispatch_get_main_queue(), ^{ Cocoa_ShowMessageBoxImpl(messageboxdata, buttonid, &returnValue); });
+#else
+        /* Call directly, like SDL <= 2.0.9 always did: the era of AppKit
+           that GCC builds target tolerates this off the main thread, and
+           the main thread may not be running a runloop to service a
+           marshalled call. */
+        Cocoa_ShowMessageBoxImpl(messageboxdata, buttonid, &returnValue);
+#endif
     }
     return returnValue;
 }}
